/**
 * 扩展按钮类
 * @type {Function|*}
 */
cc.bsButton = cc.Class({
    extends: cc.Component,
    editor: {
        requireComponent: cc.Button,

    },
    ctor: function () {
        this.onClicks = cc.bsList(); //  点击事件容器
    },

    properties: {
        //  是否标准化
        isOther: true,
        isNormal: true,

        //    点击音效
        clickAudio: {
            type: cc.AudioClip,
            default: null,

        },

    },
    init: function () {
        //  标准化处理
        if (this.isNormal) {
            this.btn.transition = cc.Button.Transition.SCALE;
            this.btn.zoomScale = 1.05;
        }
    },

    // LIFE-CYCLE CALLBACKS:

    onLoad: function () {

        this.btn = this.node.getComponent(cc.Button);
        console.log("我到里了");
        //  监听触摸开始事件
        this.node.on(cc.Node.EventType.TOUCH_START, event => {
          
        }, this);
        //  监听触摸移动事件
        this.node.on(cc.Node.EventType.TOUCH_MOVE, event => {

        }, this);
        //  监听触摸离开事件
         this.node.on(cc.Node.EventType.TOUCH_END, event => {
            if (this.btn.interactable) {
                this.onClicks.each(listener => {
                    listener.call(listener.context, event);
                });
            }

         }, this);
        this.init();
    },

    start() {

    },

    update(dt) {

    },
    onDisable: function () {
        //  重置按钮状态
        if (this.btn)
            this.btn._transitionFinished = true;

        this.node.setScale(1, 1);
    },

    onDestroy: function () {
        this.node.targetOff(this);
        this.removeAllClickListener();
    },

    /**
     * 添加点击事件
     * @param callback
     * @param context
     * @returns {cc.bsButton}
     */
    addClickListener: function (callback, context) {
        if (!callback)
            return this;

        callback.context = context || this;
        this.onClicks.append(callback);

        return this;
    },

    /**
     * 移除点击事件
     * @param callback
     * @returns {cc.bsButton}
     */
    removeClickListener: function (callback) {
        this.onClicks.remove(callback);
        return this;
    },

    /**
     * 清空所有点击事件
     */
    removeAllClickListener: function () {
        this.onClicks.clear();
    },

});
