

cc.Class({
    extends: cc.Component,

    properties: {
        videoName: '',//当前视频名字，可以从数组中拿到
        isChoose: false,//确定当前是否做出了选择
        videoType: '',//当前播放视频中出现的选择形式状态
        nowVideokey: '0',//当前播放视频的key
        nextVideoKey: '0',//播放下一个视频的key，如果选择了，则动态修改，如果未选择，则并播放默认的
        chooseNextKey: '0',//数组，存放下一步选择的key,如果未选择，则使用默认的第一个
        unlock: false,


        videoPlayer: cc.VideoPlayer,//视频
        playVideoArea: cc.Node,//播放按钮
        sliderNode: cc.Node,  //滑动按钮节点
        longPressNode: cc.Node, //长按按钮节点
        img: cc.Node,
        chouseBtn: cc.Node,  //选择按钮节点
        addBtnNode: cc.Node, //加速按钮节点
        video: {
            type: cc.Asset,
            default: []
        }

    },

    // LIFE-CYCLE CALLBACKS:

    onLoad() {

    },
    start() {

        this.initCanvasInfo();
        //   cc.bsMethod.playType();
        this.initBtnEvent();
        this.initPlayVideo();

    },
    initCanvasInfo() {
        cc.macro.ENABLE_TRANSPARENT_CANVAS = true;
        cc.Camera.main.backgroundColor = cc.color(0, 0, 0, 0);
        console.log(cc.macro.ENABLE_TRANSPARENT_CANVAS);
        let video0 = document.getElementsByClassName('cocosVideo')[0];

        video0.autoplay = "autoplay";
        // video0.loop = "loop";
        // video0.src = "video.ogg";
        video0.style.zIndex = 5;
        console.log(video0.autoplay.preload);
        let gCanvas = document.getElementsByClassName('gameCanvas')[0];
        // document.getElementById("").playbackRate=2;
        gCanvas.style.position = 'relative';
        gCanvas.style.zIndex = 10;
        console.log(video0);
    },
    initBtnEvent() {
        this.chouseBtn.getChildByName("A").getComponent(cc.bsButton).addClickListener(() => {
            if (this.chooseNextKey.length > 0) {
                this.nextVideoKey = this.chooseNextKey[0];

                this.initVideoData(this.nextVideoKey);
            }
            this.chouseBtn.active = false;
            this.isChoose = true;
        });
        this.chouseBtn.getChildByName("B").getComponent(cc.bsButton).addClickListener(() => {
            if (this.chooseNextKey.length > 1) {
                this.nextVideoKey = this.chooseNextKey[1];

                this.initVideoData(this.nextVideoKey);
            }
            this.chouseBtn.active = false;
            this.isChoose = true;
        });

        this.chouseBtn.getChildByName("C").getComponent(cc.bsButton).addClickListener(() => {
            if (this.chooseNextKey.length > 2) {
                this.nextVideoKey = this.chooseNextKey[2];

                this.initVideoData(this.nextVideoKey);


            }
            this.chouseBtn.active = false;
            this.isChoose = true;
        });
        this.addBtnNode.getChildByName("add_1").getComponent(cc.bsButton).addClickListener(() => {
            document.getElementsByClassName('cocosVideo')[0].playbackRate = 1;
            console.log("播放速度1.0");
        });
        this.addBtnNode.getChildByName("add_2").getComponent(cc.bsButton).addClickListener(() => {
            document.getElementsByClassName('cocosVideo')[0].playbackRate = 1.5;
            console.log("播放速度1.5");
        });
        this.addBtnNode.getChildByName("add_3").getComponent(cc.bsButton).addClickListener(() => {
            document.getElementsByClassName('cocosVideo')[0].playbackRate = 2;
            console.log("播放速度2.0");


        });

        this.times = cc.bsComfing.timesAll[1];
        this.isloog = false;
        //  监听触摸开始事件
        this.longPressNode.on(cc.Node.EventType.TOUCH_START, event => {
            this.isloog = true;
        }, this);
        //  监听触摸离开事件
        this.longPressNode.on(cc.Node.EventType.TOUCH_END, event => {
            this.isloog = false;
            console.log(this.times);
            this.times = cc.bsComfing.timesAll[1];
            if (this.img.getComponent(cc.Sprite).fillRange > -1) {
                this.img.getComponent(cc.Sprite).fillRange = 0;

                this.initVideoData(this.nextVideoKey);

            }
            else {
                if (this.chooseNextKey.length >= 1) {
                    this.nextVideoKey = this.chooseNextKey[1];

                    this.initVideoData(this.nextVideoKey);

                }
                this.img.getComponent(cc.Sprite).fillRange = 0;
                this.longPressNode.active = false;
                this.isChoose = true;


            }

        }, this);

    },
    initPlayVideo() {

        this.playVideoArea.on('touchend', () => {
            this.initVideoData('0');
            this.playVideoArea.active = false;
        });

    },

    initVideoData(nextKey) {
        if (!nextKey) { console.log("播放结束！"); return; }
        let video0 = document.getElementsByClassName('cocosVideo')[0];

        video0.autoplay = "autoplay";
        video0.loop = "loop";
        // video0.src = "video.ogg";

        let data = cc.bsMethod.getNextVideo(nextKey);
        this.videoName = data.videoName;
        this.isChoose = data.isChoose;
        this.videoType = data.videoType;
        this.nowVideokey = data.nowVideokey;
        this.nextVideoKey = data.nextVideoKey;
        this.chooseNextKey = data.chooseNextKey;

        // this.videoPlayer.getComponent(cc.VideoPlayer).clip = data.video;
        this.videoPlayer.getComponent(cc.VideoPlayer).remoteURL = data.video;

        //  this.videoPlayer.getComponent(cc.VideoPlayer).playbackRate = 1.5;
        this.videoPlayer.play();
        console.log(video0);
    },

    play() {
        let isplay = this.videoPlayer.isPlaying();
        if (!isplay) {
            this.videoPlayer.play();

        } else {
            this.videoPlayer.pause();
        }
    },
    sliderBtn() {

        let count = this.sliderNode.getComponent(cc.Slider).progress;
        console.log(count);
        if (count > 0.85 && count <= 1) {
            this.sliderNode.active = false;
            if (this.chooseNextKey.length >= 1) {
                this.nextVideoKey = this.chooseNextKey[1];

                this.initVideoData(this.nextVideoKey);

            }
        } else {

            this.initVideoData(this.nextVideoKey);

        }
    },
    nextVideoBtn() {

        this.videoPlayer._impl._video.currentTime = (this.videoPlayer.getDuration() - 5);
        this.videoPlayer.play();
        console.log("我是跳过视频中间部分视频按钮");
    },

    onVideoPlayerEvent(sender, event) {
        //  this.statusLabel.string = 'Status: ' + getStatus(event);
        if (event === cc.VideoPlayer.EventType.CLICKED) {
            if (this.videoPlayer.isPlaying()) {
                this.videoPlayer.pause();
            } else {
                this.videoPlayer.play();
            }
        }
        else if (event === cc.VideoPlayer.EventType.READY_TO_PLAY || event === cc.VideoPlayer.EventType.META_LOADED) {
            // this.controlButtons.active = true;
            // this.playVideoArea.active = true;

            this.chouseBtn.active = false;
            this.longPressNode.active = false;
            this.sliderNode.active = false;
            console.log("我正在播放？？？？？？？？？？");
        }
        else if (event === cc.VideoPlayer.EventType.PLAYING) {
            // console.log(this.videoPlayer)
        }
        if (event === cc.VideoPlayer.EventType.COMPLETED) {
            console.log(sender)
            console.log("播放结束！");
            console.log(event);
            //   this.initVideoData(this.nextVideoKey);


        }
    },



    update(dt) {

        if (this.videoPlayer.currentTime && this.videoPlayer.currentTime > (this.videoPlayer.getDuration() - 5) && this.videoPlayer.currentTime < this.videoPlayer.getDuration()) {
            if (this.videoType == '0') {
                if (!this.isChoose) {
                    this.chouseBtn.active = true;

                }

            } else if (this.videoType == '1') {
                if (!this.isChoose) {
                    this.longPressNode.active = true;

                }

            }
            else if (this.videoType == '2') {
                if (!this.isChoose) {
                    this.sliderNode.active = true;

                }
            }
            else if (this.videoType == '3') {

            }

        }


        if (this.isloog && this.times >= 0) {
            this.times -= dt;
            cc.bsMethod.longPress(1, this.img, dt);
        }
    },
});
